import os, subprocess, math

results = {}
conf = {}
# comment in the following line to replace sched_yield with a no-op function
#os.putenv ('LD_PRELOAD', os.path.join (os.getcwd (), 'libyield.so'))

for cpus in range(2,10,1) + range(10,100,5) + range(100, 1000, 100) + [1000,]:
	if cpus not in conf:
		conf[cpus] = {}
	print cpus, 'cpus'
	# reduce number of loops with growing problem size (i.e. threads)
	barrierruns = 1000*(10**(4-int(math.ceil(math.log(cpus,10)))))
	conf[cpus]['barrierruns'] = barrierruns
	open ('cpuconf.h', 'w').write ('#define THREADS_NUM %i\n#define THREAD_NUM_LOG2 %i\n#define BARRIERRUNS %i\n' % (cpus, math.ceil (math.log (cpus, 2)), barrierruns))
	subprocess.call ('make')

	for prog in ('./counter', './dissemination_optimized', './mcs_optimized'):
		print 'running', prog
		if prog not in results:
			results[prog] = {}
		for i in xrange (10):
			if cpus not in results[prog]:
				results[prog][cpus] = []
			p = subprocess.Popen ([prog], stdout=subprocess.PIPE)
			# the program prints its runtime in ns to stdout
			# needs '#define printf' in config.h
			t = int (p.communicate ()[0])
			print t
			results[prog][cpus].append (t)

for prog, val in results.iteritems ():
	print prog
	for cpus, val in val.iteritems ():
		val = map (float, val)
		mean=sum(val)/len(val)
		stddev=math.sqrt(sum(map(lambda x: (x-mean)**2, val))/len(val))
		print '%i\t%i\t%i\t%i' % (cpus, conf[cpus]['barrierruns'], mean, stddev)

